/**
 * Client.java
 * Created on 2005/06/17
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package izayoi.client;

import izayoi.Constants;
import izayoi.Util;
import izayoi.cache.CacheEntry;
import izayoi.cache.CacheFactory;
import izayoi.cache.Record;
import izayoi.client.agent.SyncAgent;
import izayoi.node.Node;
import izayoi.node.NodeController;
import izayoi.node.NodeControllerFactory;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.ProtocolException;
import java.net.URL;

import edu.emory.mathcs.backport.java.util.Queue;
import edu.emory.mathcs.backport.java.util.concurrent.LinkedBlockingQueue;

/**
 * uNCAgv
 * @author es
 */
public class Client {

    private class Executer extends Thread {
        final Client client;
        boolean b;

        Executer(Client c) {
            client = c;
            b = true;
        }

        /* ( Javadoc)
         * @see java.lang.Runnable#run()
         */
        public void run() {
            while (b) {
                Agent m = (Agent) _cue.poll();
                if (m != null) {
                    try {
                        m.invoke();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
                try {
                    sleep(5000);
                } catch (InterruptedException e) {
                    b = false;
                    e.printStackTrace();
                    break;
                }
            }
        }
    }

    private static final Client _me = new Client();
    private Queue _cue = new LinkedBlockingQueue();
    private Executer _thread;
    private NodeController _node;
    private CacheFactory _cache;

    public static Client getInstance() {
        return _me;
    }

    private Client() {
        _node = NodeControllerFactory.getInstance();
        _cache = CacheFactory.getInstance();
        _thread = new Executer(this);
        _thread.start();
    }

    /**
     * @param method
     * @param arg
     */
    public void addQueue(Agent agent) {
        if (agent == null) {
            return;
        }
        _cue.add(agent);
    }

    /**
     * @return
     */
    public boolean hasQueue() {
        return _cue.size() != 0;
    }

    /**
     * 
     */
    public synchronized void stop() {
        _thread.b = false;
        _thread = null;
    }

    //    /**
    //     * w肵LbV̓ewm[h̃LbVeŏ㏑<br>
    //     * wm[hYLbVĂȂꍇAȂ<br>
    //     * @param arg ^Cv, O, m[h
    //     * @throws IOException
    //     */
    //    public void override(String[] arg) throws IOException {
    //        if (arg == null || arg.length < 3) {
    //            return;
    //        }
    //        String type = arg[0];
    //        String basename = arg[1];
    //        String filename = Util.getFileName(type, basename);
    //        Node node = _node.getNode(new URL(arg[2]));
    //        if (node == null) {
    //            return;
    //        }
    //
    //        Record[] r = null;
    //        try {
    //            r = node.get(filename, "0-");
    //        } catch (ProtocolException e) {
    //            e.printStackTrace();
    //            return;
    //        }
    //
    //        CacheEntry cache = _cache.getEntry(type, basename, true);
    //        cache.purge();
    //        cache.append(r);
    //    }
    //
    //    /**
    //     * w肵LbV̍ŏIXVȍ~̃R[h݂̑𒲍AΎ荞<br>
    //     * list ̏ꍇlist link ɂĂċAIɏs
    //     * @param arg ^Cv, O [, m[h]
    //     * @throws IOException
    //     */
    //    public void scanUpdate(String[] arg) throws IOException {
    //        if (arg == null || arg.length < 2) {
    //            return;
    //        }
    //
    //        String type = arg[0];
    //        String basename = arg[1];
    //        String nodeUrl = (arg.length > 2) ? arg[2] : null;
    //        Node node = (nodeUrl != null) ? _node.getNode(new URL(nodeUrl)) : _node.getRandomNode();
    //        if (node == null) {
    //            return;
    //        }
    //
    //        CacheEntry cache = _cache.getEntry(type, basename);
    //        long l;
    //        if (cache != null) {
    //            l = cache.getLastModified();
    //        } else {
    //            l = 0;
    //        }
    //
    //        Record[] r = null;
    //        try {
    //            r = node.get(Util.getFileName(type, basename), l + "-");
    //        } catch (ProtocolException e) {
    //            //
    //        }
    //        if (r == null || r.length == 0) {
    //            return;
    //        }
    //
    //        if (cache == null) {
    //            cache = _cache.getEntry(type, basename, true);
    //        }
    //
    //        if (type.equals(Constants.TYPE_LIST)) {
    //            for (int i = 0; i < r.length; i++) {
    //                if (!r[i].isDeletedRecord()) {
    //                    String lname = r[i].getField(Constants.FIELD_NAME_LINK);
    //                    String ltype = r[i].getField(Constants.FIELD_NAME_TYPE);
    //                    String[] param;
    //                    if (nodeUrl != null) {
    //                        param = new String[] { ltype, lname, nodeUrl };
    //                    } else {
    //                        param = new String[] { ltype, lname };
    //                    }
    //                    //addQueue("scanUpdate", param);
    //                }
    //            }
    //        }
    //        cache.append(r);
    //    }

    /**
     * XV
     * @param nodeUrl Ώۃm[h (nullŃ_)
     * @param filename ΏۃLbṼt@C
     * @param timestamp 
     * @param id ʎq
     * @throws IOException
     */
    public void syncUpdate(URL nodeUrl, String filename, long timestamp, String id) throws IOException {
        if (filename == null || id == null) {
            return;
        }

        Node node = (nodeUrl == null) ? _node.getRandomNode() : _node.getNode(nodeUrl);
        if (node == null) {
            return;
        }

        SyncAgent sync = new SyncAgent(this, node, _cache.getEntry(filename, true));
        sync.setTimeStamp(timestamp);
        sync.setID(id);
        addQueue(sync);
    }
}
